SetCommonData("rank", "Normal"); 
CreateRenderTarget("tex");
CreateRenderTarget("target");
let path; let s=0;
ascent(i in 0..20){
SetAreaCommonData("replay", i, "--/--/-- ---------- -------- -------");
}
let pause=false;
ascent(i in 0..3){
SetAreaCommonData("graphic", i, 0);
}
let MainSTG = GetCurrentScriptDirectory;
let FuncSrc = GetCurrentScriptDirectory;
let frame = MainSTG~"/img/select00.png";
let MENU=0;
let MENU_TEXT=["Start", "Replay", "Quit game"];
let objtex=[0, 0, 0, 0, 0, 0, 0];
let title=ObjPrim_Create(OBJ_SPRITE_2D);

let MENU_SELECT=0;
let aalpha=0;
let id=LoadScript(GetCurrentScriptDirectory~"/system/Default_Pause.txt");
InstallFont(MainSTG~"/system/TickingTimebombBB.ttf");

let xa=250; let speed=0;
let start=false;
task MainMenu(MENU_TYPE){
alternative (MENU_TYPE)
case (0) {
}
case (1) {
MainMenuA1;
}
case (2) {

}
yield;
}


task MenuReplay{
MenuBG(3);
LoadReplayList;
GetValidReplayIndices;
loop(60){yield;}
let select=1;
KeyCheck;
let tex=["", "", "", "", "", "", "", "", "", "", ""];
ascent(i in 1..11){
if (IsValidReplayIndex(i)){
tex[i]=ToString(GetReplayInfo(i, REPLAY_USER_NAME)~" "~GetReplayInfo(i, REPLAY_PLAYER_NAME)~" "~GetReplayInfo(i, REPLAY_DATE_TIME));}
else {tex[i]="No replay";}}
ascent(i in 1..length(tex)){DrawText(tex[i], i);}

task DrawText(string, number){
let ang=0;
let obj=ObjText_Create();
ObjText_SetFontSize(obj, 32);
ObjRender_SetPosition(obj, 32, 74+number*30, 0);
ObjText_SetFontBold(obj, true);
ObjText_SetFontType(obj, "Ticking Timebomb BB");
ObjText_SetFontBorderType(obj, BORDER_SHADOW);
ObjText_SetFontBorderWidth(obj, 2);
ObjText_SetFontBorderColor(obj, 40, 40, 40);
ObjText_SetText(obj, tex[number]);
while(!Obj_IsDeleted(obj)){
	if (select==number){
	ang+=8;
	ObjText_SetFontColorTop(obj, 220+35*sin(ang), 220+35*sin(ang), 220+35*sin(ang));
	ObjText_SetFontColorBottom(obj, 115+35*sin(ang), 115+35*sin(ang), 115+35*sin(ang));}
	else{
	ang=0;
	ObjText_SetFontColorTop(obj, 100, 100, 100);
	ObjText_SetFontColorBottom(obj, 100, 100, 100);
	}
if (MENU!=3){FadeOut;}
yield;}

function FadeOut{
let alpha=255;
loop(30){alpha-=255/30; ObjRender_SetAlpha(obj, alpha); yield;} Obj_Delete(obj);
}
}

task KeyCheck{
	loop(60){yield;}
	MENU_SELECT=0;
	while(MENU==3){
	if (GetVirtualKeyState(VK_DOWN)==KEY_PUSH){select++; if (select>length(tex)-1){select=1;}}
	if (GetVirtualKeyState(VK_UP)==KEY_PUSH){select--; if (select<1){select=length(tex)-1;}}
	if (GetVirtualKeyState(VK_BOMB)==KEY_PUSH){MENU=1; MainMenu(MENU);}
	if (GetVirtualKeyState(VK_SHOT)==KEY_PUSH){s=select; ReplayStage(1); MENU=4;}
	yield;}
	}

}

task Transition{
let alpha=0;
let obj=ObjPrim_Create(OBJ_SPRITE_2D);
ObjPrim_SetTexture(obj, GetCurrentScriptDirectory~"/img/transition.png");
ObjSprite2D_SetSourceRect(obj, 0, 0, 128, 128);
Obj_SetRenderPriority(obj, 1);
ObjSprite2D_SetDestRect(obj, 0, 0, GetScreenWidth, GetScreenHeight);
ObjRender_SetBlendType(obj, BLEND_SUBTRACT);
loop(60){alpha+=255/60;
ObjRender_SetAlpha(obj, alpha);
yield;}
loop(30){yield;}
loop(30){
alpha-=255/30;
ObjRender_SetAlpha(obj, alpha);
yield;}
Obj_Delete(obj);
}
task PlaySoundEffect(sound){
let se=ObjSound_Create;
ObjSound_Load(se, GetCurrentScriptDirectory~"system/se/"~sound~".wav");
ObjSound_Play(se);
}
task Stage(stageid){
		loop(60){yield;}
		let string=ToString(stageid);
		descent(i in 1..length(string)){string=erase(string, i);}
		path=GetCurrentScriptDirectory~"stage"~string~".txt";
		InitializeStageScene;
		
		SetStageIndex(stageid);
		SetStageMainScript(path);
		SetStagePlayerScript(GetCurrentScriptDirectory~"/player/gt_Medicine/PracticeP.TXT");
		StartStageScene;

		while(GetStageSceneState!=STAGE_STATE_FINISHED){
		RenderToTextureA1("target", 0, 89, true);
		if(GetVirtualKeyState(VK_PAUSE) == KEY_PUSH)
		{PlaySoundEffect("se_pause");
			let resPause = RunPauseScene();
			alternative(resPause)
			case(RESULT_RETRY)
			{
				//最初からやり直す
				if(!IsReplay())
				{
					//リトライ
					TerminateStageScene();
					Stage(1);
					return;
				}
			}
			case(RESULT_END)
			{
				ClosePackage;
			}
		}
		
		yield;}
		FinalizeStageScene;
		let resEnd=RunEndScene;
		alternative(resEnd)
		case (RESULT_SAVE_REPLAY){
		StartScript(LoadScript(GetCurrentScriptDirectory~"/System/Default_ReplaySaveScene.txt"));
		}
		case (RESULT_RETRY){TerminateStageScene; 
		Stage(1); return;}
		case (RESULT_END){ClosePackage;}
		
}

task ReplayStage(stageid){
		loop(60){yield;}
		let string=ToString(stageid);
		descent(i in 1..length(string)){string=erase(string, i);}
		path=GetCurrentScriptDirectory~"stage"~string~".txt";
		InitializeStageScene;
		SetStageReplayFile(GetReplayInfo(s, REPLAY_FILE_PATH));
		SetStageIndex(stageid);
		SetStageMainScript(path);
		SetStagePlayerScript(GetCurrentScriptDirectory~"/player/gt_Medicine/PracticeP.TXT");
		StartStageScene;
		while(GetStageSceneState!=STAGE_STATE_FINISHED){
		RenderToTextureA1("target", 0, 89, true);
		if(GetVirtualKeyState(VK_PAUSE) == KEY_PUSH)
		{PlaySoundEffect("se_pause");
			let resPause = RunPauseScene();
			alternative(resPause)
			case(RESULT_RETRY)
			{
				//最初からやり直す
				
					//リトライ
					TerminateStageScene();
					ReplayStage(1);
					return;
			}
			case(RESULT_END)
			{
				ClosePackage;
			}
		}
		
		yield;}
		FinalizeStageScene;
		let resEnd=RunEndScene;
		alternative(resEnd)
		case (RESULT_SAVE_REPLAY){
		StartScript(LoadScript(GetCurrentScriptDirectory~"/System/Default_ReplaySaveScene.txt"));
		}
		case (RESULT_RETRY){TerminateStageScene; 
		ReplayStage(1); return;}
		case (RESULT_END){ClosePackage;}
		
}

function RunEndScene()
{let endgame=true;
SetInvalidRenderPriorityA1(0, 89);


	task TVertex(r, var left, var top, var right, var bottom, size, alpha)
	{
	//分割設定
	let frame = 30;
	let countH = 20; //分割数
	let countV = 30; 
	let width = 640 / countH;
	let height = 480 / countV;
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D); //2D頂点ブジェクト生成
	Obj_SetRenderPriorityI(obj, 90); //描画優先度を設定
	ObjPrim_SetTexture(obj, "target"); //テクスチャを設定
	ObjSprite2D_SetSourceRect(obj, 0, 0, 640, 480);
	ObjSprite2D_SetDestCenter(obj);
	ObjRender_SetAlpha(obj, alpha);
	//ObjRender_SetBlendType(obj, BLEND_ADD_ARGB);
	ObjRender_SetScaleXYZ(obj, size, size, 0);
	ObjRender_SetPosition(obj, 320, 240, 0);
	while(endgame==true){
	yield;}
	ClearInvalidRenderPriority;
	Obj_Delete(obj);
	}
		ascent(r in 0..6)
		{
			TVertex(r, 0, 0, 640, 480, 1+r/60, 100-r*100/6);
		}
		
	PauseStageScene(true);

	let pathScript = GetCurrentScriptDirectory ~ "system/Default_EndScene.txt";

	//--------------------------------
	//一時停止シーンンスクリプト起動
	let idScript = LoadScript(pathScript);
	StartScript(idScript);

	while(!IsCloseScript(idScript))
	{
		yield;
	}
	endgame=false;

	let res = GetScriptResult(idScript);
	return res;
}


function RunPauseScene()
{pause=true;
SetInvalidRenderPriorityA1(0, 89);
RenderToTextureA1("target", 0, 89, true);

	task TVertex(r, var left, var top, var right, var bottom, size, alpha)
	{
	//分割設定
	let frame = 30;
	let countH = 20; //分割数
	let countV = 30; 
	let width = 640 / countH;
	let height = 480 / countV;
	
	let obj = ObjPrim_Create(OBJ_SPRITE_2D); //2D頂点ブジェクト生成
	Obj_SetRenderPriorityI(obj, 90); //描画優先度を設定
	ObjPrim_SetTexture(obj, "target"); //テクスチャを設定
	ObjSprite2D_SetSourceRect(obj, 0, 0, 640, 480);
	ObjSprite2D_SetDestCenter(obj);
	ObjRender_SetAlpha(obj, alpha);
	//ObjRender_SetBlendType(obj, BLEND_ADD_ARGB);
	ObjRender_SetScaleXYZ(obj, size, size, 0);
	ObjRender_SetPosition(obj, 320, 240, 0);
	while(pause==true){
	yield;}
	ClearInvalidRenderPriority;
	Obj_Delete(obj);
	}
		ascent(r in 0..6)
		{
			TVertex(r, 0, 0, 640, 480, 1+r/60, 100-r*100/6);
		}
		
	PauseStageScene(true);

	let pathScript = GetCurrentScriptDirectory ~ "system/Default_Pause.txt";

	//--------------------------------
	//一時停止シーンンスクリプト起動
	let idScript = LoadScript(pathScript);
	StartScript(idScript);

	while(!IsCloseScript(idScript))
	{
		yield;
	}
	pause=false;

	PauseStageScene(false);

	let res = GetScriptResult(idScript);
	return res;
}


task MenuBG(menu){
let obj=ObjPrim_Create(OBJ_SPRITE_2D);
if (menu==1){ObjPrim_SetTexture(obj, GetCurrentScriptDirectory~"/img/title.png");}
else{ObjPrim_SetTexture(obj, GetCurrentScriptDirectory~"/img/repmenu.png");}
ObjSprite2D_SetSourceRect(obj, 0, 0, 640, 480);
ObjSprite2D_SetDestRect(obj, 0, 0, 640, 480);
Obj_SetRenderPriority(obj, 0.5);
while(MENU==menu){yield;}
loop(60){yield;}
Obj_Delete(obj);
}
task LoadingScreen{
let obj=ObjPrim_Create(OBJ_SPRITE_2D);
ObjPrim_SetTexture(obj, GetCurrentScriptDirectory~"/img/loading.png");
ObjSprite2D_SetSourceRect(obj, 0, 0, 640, 480);
ObjSprite2D_SetDestRect(obj, 0, 0, 640, 480);
let angle=0;
let obj2=ObjPrim_Create(OBJ_SPRITE_2D);
ObjPrim_SetTexture(obj2, GetCurrentScriptDirectory~"/img/load_icon.png");
ObjSprite2D_SetSourceRect(obj2, 0, 0, 44, 44);
ObjSprite2D_SetDestCenter(obj2);
ObjRender_SetPosition(obj2, 320, 230, 0);

	Transition;
	loop(60){yield;}
	Obj_Delete(obj); Obj_Delete(obj2);
	MENU=1; 
	MainMenuA1;
}
task MainMenuA1{
let sel=0;
MenuBG(1);
Cursor;
KeyCheck;
	task Cursor{
	
	let tex=[ObjText_Create,ObjText_Create,ObjText_Create];
	let diftex=["Normal", "Hard"];
	let text2=[ObjText_Create,ObjText_Create];
	ascent(i in 0..2){ObjText_SetFontType(text2[i], "Ticking Timebomb BB");
	ObjText_SetText(text2[i], diftex[i]);
	ObjText_SetFontBorderWidth(text2[i], 3);
	ObjText_SetFontBorderType(text2[i], BORDER_SHADOW);
	ObjText_SetFontBorderColor(text2[i], 40, 40, 40);
	ObjText_SetFontSize(text2[i], 32);
	ObjRender_SetPosition(text2[i], 210, 190, 0);
	}
	
	ascent(i in 0..3){ObjText_SetFontType(tex[i], "Ticking Timebomb BB");
	ObjText_SetFontBorderWidth(tex[i], 3);
	ObjText_SetFontBorderType(tex[i], BORDER_SHADOW);
	ObjText_SetFontBorderColor(tex[i], 40, 40, 40);
	ObjText_SetFontSize(tex[i], 32);}
	let alpha=255; let angle=0;
	while(MENU==1){
	
	angle+=3;
	alpha=200+55*cos(angle*3);
	ascent(i in 0..2){if (sel==i){Obj_SetVisible(text2[i], true);} else{Obj_SetVisible(text2[i], false);}
	if (MENU_SELECT==0){ObjText_SetFontColorTop(text2[i], alpha, alpha, alpha);
	ObjText_SetFontColorBottom(text2[i], 150, 150, 150);}
	else{ObjText_SetFontColorTop(text2[i], 100, 100, 100);
	ObjText_SetFontColorBottom(text2[i], 100, 100, 100);}
	}
	ascent(i in 0..3){
	if (MENU_SELECT==i){
		SetCommonData("rank", diftex[sel]);
	ObjText_SetFontColorTop(tex[i], alpha, alpha, alpha);
	ObjText_SetFontColorBottom(tex[i], 150, 150, 150);}
	else{ObjText_SetFontColorTop(tex[i], 100, 100, 100); 
	ObjText_SetFontColorBottom(tex[i], 100, 100, 100);}
	ObjText_SetText(tex[i], MENU_TEXT[i]);
	ObjRender_SetPosition(tex[i], 90+15*i, 190+60*i, 0);}
	
	yield;}
	ascent(i in 0..2){Obj_Delete(text2[i]);}
	ascent(i in 0..3){Obj_Delete(tex[i]);}
	
	}
	task KeyCheck{
	loop(60){yield;}
	MENU_SELECT=0;
	while(MENU==1){
	if (MENU_SELECT==0){
	if (GetVirtualKeyState(VK_LEFT)==KEY_PUSH){sel--; if (sel<0){sel=1;}}
	if (GetVirtualKeyState(VK_RIGHT)==KEY_PUSH){sel++; if (sel>1){sel=0;}}
	}
	if (GetVirtualKeyState(VK_DOWN)==KEY_PUSH){MENU_SELECT++; if (MENU_SELECT>2){MENU_SELECT=0;}
	
	}
	if (GetVirtualKeyState(VK_UP)==KEY_PUSH){MENU_SELECT--; if (MENU_SELECT<0){MENU_SELECT=2;}
	
	}
	if (GetVirtualKeyState(VK_BOMB)==KEY_PUSH&&MENU_SELECT!=2){MENU_SELECT=2;}
	if (GetVirtualKeyState(VK_SHOT)==KEY_PUSH){
	MENU=MENU_SELECT+2;
		alternative(MENU_SELECT)
		case (0){
		Transition;
		loop(60){yield;}
		Stage(1);
		}
		case(1){
		MenuReplay;
		}
		case (2){ClosePackage;}
	
	}
	yield;}
	}
	
	
}